#!/usr/bin/perl
#------------------------------------------------------------------------------
#    59Tracker, weblog software for personal publisher.
#    Copyright (C) 2004-2009 Kaga, Hiroaki
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#------------------------------------------------------------------------------
use strict;
use warnings;

use CGI;

my $cgi = CGI->new();
my $target = $cgi->param('target');
if ($target ne '') {
    my $url = '';
    my $date = $cgi->param('date');
    if ($date) {
        $url = "./?date=$date";
        print "Status: 302 Moved Permanently\n";
        print "Location: $url", "\n\n";
        exit;
    }
    my $q = $cgi->param('q');
    my $page = $cgi->param('page');
    if ($q) {
        $q =~ s/(\W)/'%' . unpack('H2', $1)/eg;  # uriパック
        $url = "./?q=$q";
        if ($page) {
            $url .= "&page=$page";
        }
        print "Status: 302 Moved Permanently\n";
        print "Location: $url", "\n\n";
        exit;
    }
}

my $act = $cgi->param('act');
if ($act eq '') {
    $act = 'view_session';
}

my ($operation, $object) = split(/_/, $act);

require "Plugins/$object.cgi";

act($act, $cgi);
